// Copyright (C) 2015 SRG Technology, LLC
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

#ifndef ANYRPC_ANYRPC_H_
#define ANYRPC_ANYRPC_H_

// This header file should normally be included by applications.

#include "api.h"
#include "logger.h"
#include "error.h"
#include "value.h"
#include "stream.h"
#include "handler.h"
#include "document.h"
#include "reader.h"
#include "method.h"
#include "socket.h"
#include "connection.h"
#include "server.h"
#include "client.h"
#include "json/jsonwriter.h"
#include "json/jsonreader.h"
#include "json/jsonserver.h"
#include "json/jsonclient.h"
#include "messagepack/messagepackwriter.h"
#include "messagepack/messagepackreader.h"
#include "messagepack/messagepackserver.h"
#include "messagepack/messagepackclient.h"
#include "xml/xmlwriter.h"
#include "xml/xmlreader.h"
#include "xml/xmlserver.h"
#include "xml/xmlclient.h"

#endif // ANYRPC_ANYRPC_H_
